﻿/**
* The AuroraBorealis class.
* 
* @author Robert Penner (AS 1.0)
* © 2002 Robert Penner
* http://www.robertpenner.com
* 
* @author Mark Walters (AS 2.0)
* © 2006 DigitalFlipbook
* http://www.digitalflipbook.com
* 
* @version	1.0
* 
* @since	ActionScript 2.0; Flash Player 6
*/
class com.robertpenner.profmx.auroraBorealis.AuroraBorealis extends MovieClip {
	
	/*
	* CLIP PARAMETERS
	*/
	private var $clipParameters:Object = {maxParticles: 1, brownInterval: 1};
	
	/*
	* INSPECTABLE PROPERTIES
	*/
	private var $maxParticles:Number;
	private var $brownInterval:Number;
	
	
	/*
	* *********************************************************
	* CONSTRUCTOR
	* *********************************************************
	*
	*/
	
	function AuroraBorealis () {
		this.initFromClipParameters();
	}
	
	
	/*
	* *********************************************************
	* PRIVATE METHODS
	* *********************************************************
	* 
	*/
	
	private function initFromClipParameters ():Void {
		var key:String, found:Boolean = false;
		for(key in $clipParameters) {
			if(this.hasOwnProperty(key)) {
				found = true;
				this["def_" + key] = this[key];
				delete this[key];
			}
		}
		if(found) {
			for(key in $clipParameters) {
				var v = this["def_" + key];
				if(v != undefined) {
					this[key] = v;
				}
			}
		}
	}
	
	private function init ():Void {
		for (var i:Number=0; i < this.$maxParticles; i++) {
			var p:MovieClip = this.attachMovie ("auroraParticle", "p" + i, i);
			p._alpha = 0;
			p.brownInterval = this.$brownInterval;
		}
	}
	
	
	/*
	* *********************************************************
	* GETTERS/SETTERS
	* *********************************************************
	* 
	*/
	
	/**
	* The maxParticles property of the AuroraBorealis.
	* 
	* @usage
	* <pre><code>
	* trace (auroraBorealis.maxParticles);
	* </code></pre>
	*/
	[Inspectable(type=Number, defaultValue=10)]
	public function get maxParticles ():Number {
		return this.$maxParticles;
	}
	public function set maxParticles (mp:Number):Void {
		 this.$maxParticles = mp;
	}
	
	/**
	* The brownInterval property of the AuroraBorealis.
	* 
	* @usage
	* <pre><code>
	* trace (auroraBorealis.brownInterval);
	* </code></pre>
	*/
	[Inspectable(type=Number, defaultValue=10)]
	public function get brownInterval ():Number {
		return this.$brownInterval;
	}
	public function set brownInterval (bi:Number):Void {
		 this.$brownInterval = bi;
	}
	
}
